devtools: fix null test

Message ID 20190717112031.10968-1-thomas@monjalon.net (mailing list archive)
State Superseded, archived
Delegated to: Thomas Monjalon
Headers
Series devtools: fix null test |

Checks

Context Check Description
ci/checkpatch success coding style OK
ci/Intel-compilation success Compilation OK
ci/intel-Performance-Testing success Performance Testing PASS
ci/mellanox-Performance-Testing success Performance Testing PASS

Commit Message

Thomas Monjalon July 17, 2019, 11:20 a.m. UTC
  This small testpmd test was not working for a long time
because of several changes in EAL and mempool.
The 3 main issues solved are:
	- Make --no-huge working by specifying an amount of memory
		to allocate in legacy mode, and disabling mlockall.
	- Load a mempool handler in shared library case.
	- Support meson

Signed-off-by: Thomas Monjalon <thomas@monjalon.net>
---
 devtools/test-null.sh | 19 ++++++++++++++-----
 1 file changed, 14 insertions(+), 5 deletions(-)
  

Patch

diff --git a/devtools/test-null.sh b/devtools/test-null.sh
index 61879e3e6..59cb0606a 100755
--- a/devtools/test-null.sh
+++ b/devtools/test-null.sh
@@ -1,17 +1,26 @@ 
 #! /bin/sh -e
 # SPDX-License-Identifier: BSD-3-Clause
 # Copyright 2015 6WIND S.A.
+# Copyright 2019 Mellanox Technologies, Ltd
 
 # Run a quick testpmd forwarding with null PMD without hugepage
 
 build=${1:-build}
 coremask=${2:-3} # default using cores 0 and 1
 
-if grep -q SHARED_LIB=y $build/.config; then
-	pmd='-d librte_pmd_null.so'
+testpmd=$build/app/dpdk-testpmd
+[ -f $testpmd ] || testpmd=$build/app/testpmd
+if [ ! -f $testpmd ] ; then
+	echo 'ERROR: testpmd cannot be found' >&2
+	exit 1
+fi
+
+unset libs
+if ldd $testpmd | grep -q librte_ ; then
+	libs='-d librte_mempool_ring.so -d librte_pmd_null.so'
 fi
 
 (sleep 1 && echo stop) |
-$build/app/testpmd -c $coremask -n 1 --no-huge \
-	$pmd --vdev net_null1 --vdev net_null2 -- \
-	--total-num-mbufs=2048 -ia
+$testpmd -c $coremask --no-huge -m 150 \
+	$libs --vdev net_null1 --vdev net_null2 -- \
+	--no-mlockall --total-num-mbufs=2048 -ia